// SONIC ROBO BLAST 2
// StarManiaKG's Little SonicCD Mode Script
//-----------------------------------------------------------------------------
// Made by Star "Guy Who Names Scripts After Him" ManiaKG.
//-----------------------------------------------------------------------------
/// \file  CDFlowers.lua
/// \brief Controls MT_SEED spawning for CDSonic.

-- ===============================================
-- For all the special build people, by the way :p
-- ===============================================

if (tsourdt3rd)
	local SonicCD_Command = CV_FindVar("soniccd");

	if (SonicCD_Command and (SonicCD_Command.flags & CV_ALLOWLUA))
		addHook("PlayerThink", function(player)
			if not (player.mo and player.mo.valid)
				return;
			end
			if not (player.mo.skin == "cdsonic")
				return;
			end

			if not (SonicCD_Command.value)
				CONS_Printf(player, "\nHey, StarManiaKG here!\nNoticed you had SonicCD mode off. Well, CDSonic requires it soo....\nTurning it back on for ya!");
				CV_Set(SonicCD_Command, 1);
			end
		end)
	end

	return;
end

-- =================================================
-- Seed spawn emulation, for all the vanilla people:
-- =================================================

local flickyTable = {
	MT_FLICKY_01_CENTER,
	MT_FLICKY_01,
	MT_FLICKY_02_CENTER,
	MT_FLICKY_02,
	MT_FLICKY_03_CENTER,
	MT_FLICKY_03,
	MT_FLICKY_04_CENTER,
	MT_FLICKY_04,
	MT_FLICKY_05_CENTER,
	MT_FLICKY_05,
	MT_FLICKY_06_CENTER,
	MT_FLICKY_06,
	MT_FLICKY_07_CENTER,
	MT_FLICKY_07,
	MT_FLICKY_08_CENTER,
	MT_FLICKY_08,
	MT_FLICKY_09_CENTER,
	MT_FLICKY_09,
	MT_FLICKY_10_CENTER,
	MT_FLICKY_10,
	MT_FLICKY_11_CENTER,
	MT_FLICKY_11,
	MT_FLICKY_12_CENTER,
	MT_FLICKY_12,
	MT_FLICKY_13_CENTER,
	MT_FLICKY_13,
	MT_FLICKY_14_CENTER,
	MT_FLICKY_14,
	MT_FLICKY_15_CENTER,
	MT_FLICKY_15,
	MT_FLICKY_16_CENTER,
	MT_FLICKY_16,
};

for index, flicky in ipairs(flickyTable)
	addHook("MobjThinker", function(mobj)
		if not (mobj and mobj.valid)
			return;
		end

		-- Flicky centers don't spawn seeds
		if not (index % 1)
			local seed = P_SpawnMobj(mobj.x, mobj.y, mobj.z+mobj.height, MT_SEED);
			P_SetObjectMomZ(seed, seed.height*2, true);
		end

		P_RemoveMobj(mobj);
	end, flicky)
end